using Autofac;

namespace AutofacDependencyInjectionCS;

internal static class Program
{
    
    // kann sein, dass das als "blabla nullable" angezeigt wird
    // aber wir sorgen zu 100% in PrepareDI dafr, dass es nicht null ist..
    // ggf. issue unterdrcken, da ich nicht berall weiterhin die warnung bekommen mchte
    public static IContainer Container { get; private set; }

    /// <summary>
    ///  The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main()
    {
        PrepareDI();
        RunApp();
    }

    private static void PrepareDI()
    {
        var builder = new ContainerBuilder();
        builder.RegisterType<DebugLogger>();
        builder.RegisterType<Form1>();
        Container = builder.Build();
    }

    private static void RunApp()
    {
        // To customize application configuration such as set high DPI settings or default font,
        // see https://aka.ms/applicationconfiguration.
        ApplicationConfiguration.Initialize();
        var frm = Container.Resolve<Form1>();
        frm.Show();
        Application.Run();
    }
}